Index: drivers/filesystems/btrfs/write.c
===================================================================
--- drivers/filesystems/btrfs/write.c	(révision 75772)
+++ drivers/filesystems/btrfs/write.c	(copie de travail)
@@ -1545,79 +1894,115 @@
             return STATUS_INTERNAL_ERROR;
         }
     }
-    
+
     stripes = ExAllocatePoolWithTag(PagedPool, sizeof(write_stripe) * c->chunk_item->num_stripes, ALLOC_TAG);
     if (!stripes) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlZeroMemory(stripes, sizeof(write_stripe) * c->chunk_item->num_stripes);
-    
+
     cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
-    
+
     if (c->chunk_item->type & BLOCK_FLAG_RAID0) {
-        Status = prepare_raid0_write(c, address, data, length, stripes);
+        Status = prepare_raid0_write(c, address, data, length, stripes, file_write ? Irp : NULL, irp_offset, wtc);
         if (!NT_SUCCESS(Status)) {
             ERR("prepare_raid0_write returned %08x\n", Status);
-            ExFreePool(stripes);
-            return Status;
+            goto prepare_failed;
         }
-        
-        if (need_free)
-            ExFreePool(data);
 
-        need_free2 = TRUE;
+        allowed_missing = 0;
     } else if (c->chunk_item->type & BLOCK_FLAG_RAID10) {
-        Status = prepare_raid10_write(c, address, data, length, stripes);
+        Status = prepare_raid10_write(c, address, data, length, stripes, file_write ? Irp : NULL, irp_offset, wtc);
         if (!NT_SUCCESS(Status)) {
             ERR("prepare_raid10_write returned %08x\n", Status);
-            ExFreePool(stripes);
-            return Status;
+            goto prepare_failed;
         }
-        
-        if (need_free)
-            ExFreePool(data);
 
-        need_free2 = TRUE;
+        allowed_missing = 1;
     } else if (c->chunk_item->type & BLOCK_FLAG_RAID5) {
-        Status = prepare_raid5_write(Irp, c, address, data, length, stripes);
+        Status = prepare_raid5_write(Vcb, c, address, data, length, stripes, file_write ? Irp : NULL, irp_offset, priority, wtc);
         if (!NT_SUCCESS(Status)) {
             ERR("prepare_raid5_write returned %08x\n", Status);
-            ExFreePool(stripes);
-            return Status;
+            goto prepare_failed;
         }
-        
-        if (need_free)
-            ExFreePool(data);
 
-        need_free2 = TRUE;
+        allowed_missing = 1;
     } else if (c->chunk_item->type & BLOCK_FLAG_RAID6) {
-        Status = prepare_raid6_write(Irp, c, address, data, length, stripes);
+        Status = prepare_raid6_write(Vcb, c, address, data, length, stripes, file_write ? Irp : NULL, irp_offset, priority, wtc);
         if (!NT_SUCCESS(Status)) {
             ERR("prepare_raid6_write returned %08x\n", Status);
-            ExFreePool(stripes);
-            return Status;
+            goto prepare_failed;
         }
-        
-        if (need_free)
-            ExFreePool(data);
 
-        need_free2 = TRUE;
+        allowed_missing = 2;
     } else {  // write same data to every location - SINGLE, DUP, RAID1
         for (i = 0; i < c->chunk_item->num_stripes; i++) {
             stripes[i].start = address - c->offset;
             stripes[i].end = stripes[i].start + length;
             stripes[i].data = data;
+            stripes[i].irp_offset = irp_offset;
+
+            if (c->devices[i]->devobj) {
+                if (file_write) {
+                    UINT8* va;
+                    ULONG writelen = (ULONG)(stripes[i].end - stripes[i].start);
+
+                    va = (UINT8*)MmGetMdlVirtualAddress(Irp->MdlAddress) + stripes[i].irp_offset;
+
+                    stripes[i].mdl = IoAllocateMdl(va, writelen, FALSE, FALSE, NULL);
+                    if (!stripes[i].mdl) {
+                        ERR("IoAllocateMdl failed\n");
+                        Status = STATUS_INSUFFICIENT_RESOURCES;
+                        goto prepare_failed;
+                    }
+
+                    IoBuildPartialMdl(Irp->MdlAddress, stripes[i].mdl, va, writelen);
+                } else {
+                    stripes[i].mdl = IoAllocateMdl(stripes[i].data, (ULONG)(stripes[i].end - stripes[i].start), FALSE, FALSE, NULL);
+                    if (!stripes[i].mdl) {
+                        ERR("IoAllocateMdl failed\n");
+                        Status = STATUS_INSUFFICIENT_RESOURCES;
+                        goto prepare_failed;
+                    }
+
+                    Status = STATUS_SUCCESS;
+
+                    _SEH2_TRY {
+                        MmProbeAndLockPages(stripes[i].mdl, KernelMode, IoReadAccess);
+                    } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+                        Status = _SEH2_GetExceptionCode();
+                    } _SEH2_END;
+
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("MmProbeAndLockPages threw exception %08x\n", Status);
+                        IoFreeMdl(stripes[i].mdl);
+                        stripes[i].mdl = NULL;
+                        goto prepare_failed;
+                    }
+                }
+            }
         }
-        need_free2 = need_free;
+
+        allowed_missing = c->chunk_item->num_stripes - 1;
     }
 
+    missing = 0;
     for (i = 0; i < c->chunk_item->num_stripes; i++) {
+        if (!c->devices[i]->devobj)
+            missing++;
+    }
+
+    if (missing > allowed_missing) {
+        ERR("cannot write as %u missing devices (maximum %u)\n", missing, allowed_missing);
+        Status = STATUS_DEVICE_NOT_READY;
+        goto prepare_failed;
+    }
+
+    for (i = 0; i < c->chunk_item->num_stripes; i++) {
         PIO_STACK_LOCATION IrpSp;
-        
-        // FIXME - handle missing devices
-        
+
         stripe = ExAllocatePoolWithTag(NonPagedPool, sizeof(write_data_stripe), ALLOC_TAG);
         if (!stripe) {
             ERR("out of memory\n");
@@ -1624,70 +2009,62 @@
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
-        if (stripes[i].start + stripes[i].skip_start == stripes[i].end - stripes[i].skip_end || stripes[i].start == stripes[i].end) {
+
+        if (stripes[i].start == stripes[i].end || !c->devices[i]->devobj) {
             stripe->status = WriteDataStatus_Ignore;
             stripe->Irp = NULL;
             stripe->buf = stripes[i].data;
-            stripe->need_free = need_free2;
+            stripe->mdl = NULL;
         } else {
             stripe->context = (struct _write_data_context*)wtc;
             stripe->buf = stripes[i].data;
-            stripe->need_free = need_free2;
             stripe->device = c->devices[i];
             RtlZeroMemory(&stripe->iosb, sizeof(IO_STATUS_BLOCK));
             stripe->status = WriteDataStatus_Pending;
-            
+            stripe->mdl = stripes[i].mdl;
+
             if (!Irp) {
                 stripe->Irp = IoAllocateIrp(stripe->device->devobj->StackSize, FALSE);
-            
+
                 if (!stripe->Irp) {
                     ERR("IoAllocateIrp failed\n");
-                    Status = STATUS_INTERNAL_ERROR;
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto end;
                 }
             } else {
                 stripe->Irp = IoMakeAssociatedIrp(Irp, stripe->device->devobj->StackSize);
-                
+
                 if (!stripe->Irp) {
                     ERR("IoMakeAssociatedIrp failed\n");
-                    Status = STATUS_INTERNAL_ERROR;
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
                     goto end;
                 }
             }
-            
+
             IrpSp = IoGetNextIrpStackLocation(stripe->Irp);
             IrpSp->MajorFunction = IRP_MJ_WRITE;
-            
+
             if (stripe->device->devobj->Flags & DO_BUFFERED_IO) {
-                stripe->Irp->AssociatedIrp.SystemBuffer = stripes[i].data + stripes[i].skip_start;
+                stripe->Irp->AssociatedIrp.SystemBuffer = MmGetSystemAddressForMdlSafe(stripes[i].mdl, priority);
 
                 stripe->Irp->Flags = IRP_BUFFERED_IO;
-            } else if (stripe->device->devobj->Flags & DO_DIRECT_IO) {
-                stripe->Irp->MdlAddress = IoAllocateMdl(stripes[i].data + stripes[i].skip_start,
-                                                        stripes[i].end - stripes[i].start - stripes[i].skip_start - stripes[i].skip_end, FALSE, FALSE, NULL);
-                if (!stripe->Irp->MdlAddress) {
-                    ERR("IoAllocateMdl failed\n");
-                    Status = STATUS_INTERNAL_ERROR;
-                    goto end;
-                }
-                
-                MmProbeAndLockPages(stripe->Irp->MdlAddress, KernelMode, IoWriteAccess);
-            } else {
-                stripe->Irp->UserBuffer = stripes[i].data + stripes[i].skip_start;
-            }
-            
+            } else if (stripe->device->devobj->Flags & DO_DIRECT_IO)
+                stripe->Irp->MdlAddress = stripe->mdl;
+            else
+                stripe->Irp->UserBuffer = MmGetSystemAddressForMdlSafe(stripes[i].mdl, priority);
+
 #ifdef DEBUG_PARANOID
-            if (stripes[i].end < stripes[i].start + stripes[i].skip_start + stripes[i].skip_end) {
-                ERR("trying to write stripe with negative length (%llx < %llx + %x + %x)\n",
-                    stripes[i].end, stripes[i].start, stripes[i].skip_start, stripes[i].skip_end);
+            if (stripes[i].end < stripes[i].start) {
+                ERR("trying to write stripe with negative length (%llx < %llx)\n", stripes[i].end, stripes[i].start);
                 int3;
             }
 #endif
 
-            IrpSp->Parameters.Write.Length = stripes[i].end - stripes[i].start - stripes[i].skip_start - stripes[i].skip_end;
-            IrpSp->Parameters.Write.ByteOffset.QuadPart = stripes[i].start + cis[i].offset + stripes[i].skip_start;
-            
+            IrpSp->Parameters.Write.Length = (ULONG)(stripes[i].end - stripes[i].start);
+            IrpSp->Parameters.Write.ByteOffset.QuadPart = stripes[i].start + cis[i].offset;
+
+            total_writing += IrpSp->Parameters.Write.Length;
+
             stripe->Irp->UserIosb = &stripe->iosb;
             wtc->stripes_left++;
 
@@ -1696,18 +2073,71 @@
 
         InsertTailList(&wtc->stripes, &stripe->list_entry);
     }
-    
+
+    if (diskacc)
+        fFsRtlUpdateDiskCounters(0, total_writing);
+
     Status = STATUS_SUCCESS;
-    
+
 end:
 
     if (stripes) ExFreePool(stripes);
-    
-    if (!NT_SUCCESS(Status)) {
+
+    if (!NT_SUCCESS(Status))
         free_write_data_stripes(wtc);
-        ExFreePool(wtc);
+
+    return Status;
+
+prepare_failed:
+    for (i = 0; i < c->chunk_item->num_stripes; i++) {
+        if (stripes[i].mdl && (i == 0 || stripes[i].mdl != stripes[i-1].mdl)) {
+            if (stripes[i].mdl->MdlFlags & MDL_PAGES_LOCKED)
+                MmUnlockPages(stripes[i].mdl);
+
+            IoFreeMdl(stripes[i].mdl);
+        }
     }
-    
+
+    if (wtc->parity1_mdl) {
+        if (wtc->parity1_mdl->MdlFlags & MDL_PAGES_LOCKED)
+            MmUnlockPages(wtc->parity1_mdl);
+
+        IoFreeMdl(wtc->parity1_mdl);
+        wtc->parity1_mdl = NULL;
+    }
+
+    if (wtc->parity2_mdl) {
+        if (wtc->parity2_mdl->MdlFlags & MDL_PAGES_LOCKED)
+            MmUnlockPages(wtc->parity2_mdl);
+
+        IoFreeMdl(wtc->parity2_mdl);
+        wtc->parity2_mdl = NULL;
+    }
+
+    if (wtc->mdl) {
+        if (wtc->mdl->MdlFlags & MDL_PAGES_LOCKED)
+            MmUnlockPages(wtc->mdl);
+
+        IoFreeMdl(wtc->mdl);
+        wtc->mdl = NULL;
+    }
+
+    if (wtc->parity1) {
+        ExFreePool(wtc->parity1);
+        wtc->parity1 = NULL;
+    }
+
+    if (wtc->parity2) {
+        ExFreePool(wtc->parity2);
+        wtc->parity2 = NULL;
+    }
+
+    if (wtc->scratch) {
+        ExFreePool(wtc->scratch);
+        wtc->scratch = NULL;
+    }
+
+    ExFreePool(stripes);
     return Status;
 }
 
@@ -1714,70 +2144,30 @@
 void get_raid56_lock_range(chunk* c, UINT64 address, UINT64 length, UINT64* lockaddr, UINT64* locklen) {
     UINT64 startoff, endoff;
     UINT16 startoffstripe, endoffstripe, datastripes;
-    UINT64 start = 0xffffffffffffffff, end = 0, logend;
-    UINT16 i;
-    
+
     datastripes = c->chunk_item->num_stripes - (c->chunk_item->type & BLOCK_FLAG_RAID5 ? 1 : 2);
-    
+
     get_raid0_offset(address - c->offset, c->chunk_item->stripe_length, datastripes, &startoff, &startoffstripe);
     get_raid0_offset(address + length - c->offset - 1, c->chunk_item->stripe_length, datastripes, &endoff, &endoffstripe);
 
-    for (i = 0; i < datastripes; i++) {
-        UINT64 ststart, stend;
-        
-        if (startoffstripe > i) {
-            ststart = startoff - (startoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (startoffstripe == i) {
-            ststart = startoff;
-        } else {
-            ststart = startoff - (startoff % c->chunk_item->stripe_length);
-        }
+    startoff -= startoff % c->chunk_item->stripe_length;
+    endoff = sector_align(endoff, c->chunk_item->stripe_length);
 
-        if (endoffstripe > i) {
-            stend = endoff - (endoff % c->chunk_item->stripe_length) + c->chunk_item->stripe_length;
-        } else if (endoffstripe == i) {
-            stend = endoff + 1;
-        } else {
-            stend = endoff - (endoff % c->chunk_item->stripe_length);
-        }
-
-        if (ststart != stend) {
-            if (ststart < start)
-                start = ststart;
-
-            if (stend > end)
-                end = stend;
-        }
-    }
-    
-    *lockaddr = c->offset + ((start / c->chunk_item->stripe_length) * c->chunk_item->stripe_length * datastripes) +
-                start % c->chunk_item->stripe_length;
-               
-    logend = c->offset + ((end / c->chunk_item->stripe_length) * c->chunk_item->stripe_length * datastripes);
-    logend += c->chunk_item->stripe_length * (datastripes - 1);
-    logend += end % c->chunk_item->stripe_length == 0 ? c->chunk_item->stripe_length : (end % c->chunk_item->stripe_length);
-    *locklen = logend - *lockaddr;
+    *lockaddr = c->offset + (startoff * datastripes);
+    *locklen = (endoff - startoff) * datastripes;
 }
 
-NTSTATUS STDCALL write_data_complete(device_extension* Vcb, UINT64 address, void* data, UINT32 length, PIRP Irp, chunk* c) {
-    write_data_context* wtc;
+NTSTATUS write_data_complete(device_extension* Vcb, UINT64 address, void* data, UINT32 length, PIRP Irp, chunk* c, BOOL file_write, UINT64 irp_offset, ULONG priority) {
+    write_data_context wtc;
     NTSTATUS Status;
     UINT64 lockaddr, locklen;
-// #ifdef DEBUG_PARANOID
-//     UINT8* buf2;
-// #endif
-    
-    wtc = ExAllocatePoolWithTag(NonPagedPool, sizeof(write_data_context), ALLOC_TAG);
-    if (!wtc) {
-        ERR("out of memory\n");
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
 
-    KeInitializeEvent(&wtc->Event, NotificationEvent, FALSE);
-    InitializeListHead(&wtc->stripes);
-    wtc->tree = FALSE;
-    wtc->stripes_left = 0;
-    
+    KeInitializeEvent(&wtc.Event, NotificationEvent, FALSE);
+    InitializeListHead(&wtc.stripes);
+    wtc.stripes_left = 0;
+    wtc.parity1 = wtc.parity2 = wtc.scratch = NULL;
+    wtc.mdl = wtc.parity1_mdl = wtc.parity2_mdl = NULL;
+
     if (!c) {
         c = get_chunk_from_address(Vcb, address);
         if (!c) {
@@ -1785,104 +2175,110 @@
             return STATUS_INTERNAL_ERROR;
         }
     }
-    
+
     if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6) {
         get_raid56_lock_range(c, address, length, &lockaddr, &locklen);
         chunk_lock_range(Vcb, c, lockaddr, locklen);
     }
-    
-    Status = write_data(Vcb, address, data, FALSE, length, wtc, Irp, c);
+
+    _SEH2_TRY {
+        Status = write_data(Vcb, address, data, length, &wtc, Irp, c, file_write, irp_offset, priority);
+    } _SEH2_EXCEPT (EXCEPTION_EXECUTE_HANDLER) {
+        Status = _SEH2_GetExceptionCode();
+    } _SEH2_END;
+
     if (!NT_SUCCESS(Status)) {
         ERR("write_data returned %08x\n", Status);
-        
+
         if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)
             chunk_unlock_range(Vcb, c, lockaddr, locklen);
-        
-        free_write_data_stripes(wtc);
-        ExFreePool(wtc);
+
+        free_write_data_stripes(&wtc);
         return Status;
     }
-    
-    if (wtc->stripes.Flink != &wtc->stripes) {
+
+    if (wtc.stripes.Flink != &wtc.stripes) {
         // launch writes and wait
-        LIST_ENTRY* le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
+        LIST_ENTRY* le = wtc.stripes.Flink;
+        BOOL no_wait = TRUE;
+
+        while (le != &wtc.stripes) {
             write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-            
-            if (stripe->status != WriteDataStatus_Ignore)
+
+            if (stripe->status != WriteDataStatus_Ignore) {
                 IoCallDriver(stripe->device->devobj, stripe->Irp);
-            
+                no_wait = FALSE;
+            }
+
             le = le->Flink;
         }
-        
-        KeWaitForSingleObject(&wtc->Event, Executive, KernelMode, FALSE, NULL);
-        
-        le = wtc->stripes.Flink;
-        while (le != &wtc->stripes) {
+
+        if (!no_wait)
+            KeWaitForSingleObject(&wtc.Event, Executive, KernelMode, FALSE, NULL);
+
+        le = wtc.stripes.Flink;
+        while (le != &wtc.stripes) {
             write_data_stripe* stripe = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-            
+
             if (stripe->status != WriteDataStatus_Ignore && !NT_SUCCESS(stripe->iosb.Status)) {
                 Status = stripe->iosb.Status;
+
+                log_device_error(Vcb, stripe->device, BTRFS_DEV_STAT_WRITE_ERRORS);
                 break;
             }
-            
+
             le = le->Flink;
         }
-        
-        free_write_data_stripes(wtc);
+
+        free_write_data_stripes(&wtc);
     }
-    
+
     if (c->chunk_item->type & BLOCK_FLAG_RAID5 || c->chunk_item->type & BLOCK_FLAG_RAID6)
         chunk_unlock_range(Vcb, c, lockaddr, locklen);
 
-    ExFreePool(wtc);
-
-// #ifdef DEBUG_PARANOID
-//     buf2 = ExAllocatePoolWithTag(NonPagedPool, length, ALLOC_TAG);
-//     Status = read_data(Vcb, address, length, NULL, FALSE, buf2, NULL, Irp);
-//     
-//     if (!NT_SUCCESS(Status) || RtlCompareMemory(buf2, data, length) != length)
-//         int3;
-//     
-//     ExFreePool(buf2);
-// #endif
-
-    return STATUS_SUCCESS;
+    return Status;
 }
 
-static NTSTATUS STDCALL write_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+_Function_class_(IO_COMPLETION_ROUTINE)
+#ifdef __REACTOS__
+static NTSTATUS NTAPI write_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#else
+static NTSTATUS write_data_completion(PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID conptr) {
+#endif
     write_data_stripe* stripe = conptr;
     write_data_context* context = (write_data_context*)stripe->context;
     LIST_ENTRY* le;
-    
+
+    UNUSED(DeviceObject);
+
     // FIXME - we need a lock here
-    
+
     if (stripe->status == WriteDataStatus_Cancelling) {
         stripe->status = WriteDataStatus_Cancelled;
         goto end;
     }
-    
+
     stripe->iosb = Irp->IoStatus;
-    
+
     if (NT_SUCCESS(Irp->IoStatus.Status)) {
         stripe->status = WriteDataStatus_Success;
     } else {
         le = context->stripes.Flink;
-        
+
         stripe->status = WriteDataStatus_Error;
-        
+
         while (le != &context->stripes) {
             write_data_stripe* s2 = CONTAINING_RECORD(le, write_data_stripe, list_entry);
-            
+
             if (s2->status == WriteDataStatus_Pending) {
                 s2->status = WriteDataStatus_Cancelling;
                 IoCancelIrp(s2->Irp);
             }
-            
+
             le = le->Flink;
         }
     }
-    
+
 end:
     if (InterlockedDecrement(&context->stripes_left) == 0)
         KeSetEvent(&context->Event, 0, FALSE);
